QGIS Application - Bug report #21372
OTB provider setup
2019-02-25 12:41 PM - Paolo Cavallini

Status: Feedback

Priority: Normal

Assignee: Rashad Kanavath

Category: Processing/OTB

Affected QGIS version:3.7(master) Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 29189
Description

In Debian, the paths to add to the config are /usr/lib/x86_64-linux-gnu/otb/applications/” and /usr’. This is not documented, and it is
difficult to find for the user. Better add it as a default (similarly for other OSs).
More generally: why is this necessary? Other backends do not need a config, and this is way easier for the user.

History

#1 - 2019-02-25 12:42 PM - Paolo Cavallini
- Category changed from Processing/Core to Processing/OTB

#2 - 2019-02-25 02:03 PM - Paolo Cavallini
- Assignee set to Rashad Kanavath

#3 - 2019-02-28 11:16 AM - Rashad Kanavath

I will list three widely used oses and my options below.

1) Windows:

OTB was removed from OSGeo4W due to issues with geos and ossim. So it cannot check a list of possible install path or use some relative path to
OSGEO4W_ROOT.

What it can have is to work on integration of OTB install (like grass) into QGIS windows installer. This will be easy and users can opt-in if they want to

download and install otb from installer menu. With that done.. ggis will be ready to use otb without any further configuration.

2) Linux/Unix
This part was distribution specific for Linux and we decided not to check a list of possible install path for otb. That part should be handled by packagers. |
will see if debian package is creating a qgis profile where | can add path to otb.

3) OSX:
I don't have a clean solution for osx to pre-configure otb provider. Maybe osgeo4mac guys can help us. [1]
https://github.com/OSGeo/homebrew-osgeo4mac/issues/431

Suggestions welcome,

#4 - 2019-02-28 11:24 AM - Rashad Kanavath

It seems like debian package can update QGIS3.ini

$ grep OTB .local/share/QGIS/QGIS3/profiles/default/QGIS/QGISS.ini
Configuration\OTB_ACTIVATE=true
Configuration\OTB_APP_FOLDER=/usr/lib/x86_64-linux-gnu/otb/applications
Configuration\OTB_FOLDER=/usr

#5 - 2019-02-28 11:48 AM - Paolo Cavallini
These seem good suggestions to me. Please check with packagers to find the best solution for each major OS.

Thanks a lot.

#6 - 2019-03-01 08:34 PM - Giovanni Manghi
- Status changed from Open to Feedback

1) Windows:

OTB was removed from OSGeo4W due to issues with geos and ossim.

out of curiosity... what issues?

#7 - 2019-03-04 04:04 PM - Rashad Kanavath

out of curiosity... what issues?

Long story in bullet points :)

- OTB depends on ossim library which uses geos and it use C++ version (works fine for otb and ossim)

- OSSIM refuse to rewrite parts of geos c++ code used because ossim is also using c++ and don't care much on geos ¢ api part.
- OTB team was not able to catchup with all activies in ossim (not a very open source friendly dev process)

- OSGeo4W remove geos c++ package even when contributed by otb team.

- Due to overhead in maintaining ossim, geos-c++, itk, and using old msvc version, otb team has to back off from process

FWIW, OTB windows package (zip, no admin required) works fine and can be easily integrated into QGIS installer...

#8 - 2019-03-04 04:04 PM - Rashad Kanavath

OSGeo4Mac had told to update qgis3 customization to find otb.
https://github.com/OSGeo/homebrew-osgeo4mac/issues/431#issuecomment-468839504

#9 - 2019-04-24 09:44 AM - Jiirgen Fischer

Rashad Kanavath wrote:

FWIW, OTB windows package (zip, no admin required) works fine and can be easily integrated into QGIS installer...

The QGIS standalone installer is made from OSGeo4W packages.
